#define G_DOUBLE

/*
 *	Test program for GLSC library
 *
 *		C language version
 */

#include <stdio.h>
#include <math.h>
#include <glsc.h>

#define	MAX	(5000)
#define	MAX_X	(40)
#define	MAX_Y	(40)
#define	PI	(3.1415926545)
#define	N	(40)

#define M	40

main ()
{
    int		i, j;
    G_REAL	array[MAX_X + 1][MAX_Y + 1], dx, dy, xx, yy;
	G_REAL  **a;

    /* Initialization and definitions */ 
    g_init ("Meta", 250.0, 160.0);
    g_device (G_BOTH);
    g_def_scale (0, 0.0, 1.0, 0.0, 1.0, 30.0, 70.0, 100.0, 72.0);
    g_def_scale (4, -1.0, 1.0, -1.0, 1.0, 30.0, 30.0, 100.0, 100.0);
    g_def_line (0, G_BLACK, 0, G_LINE_SOLID);

    /* Contour lines and bird eye's view */  
    dx = PI * 4 / MAX_X;
    dy = PI * 3 / MAX_Y;
    for (j = 0; j <= MAX_Y; j ++)
    {
	yy = dy * (j - MAX_Y / 2);
	for (i = 0; i <= MAX_X; i ++)
	{
	    xx = dx * (i - MAX_X / 2);
	    array[i][j] = sin (xx - 0.3) * cos (yy - 0.2);
	}
    }

    g_cls ();
    g_hidden (1.0, 1.0, 0.4, -1.0, 1.0, 5.0, 25.0, 20.0, 20.0, 20.0,
	      150.0, 100.0, (G_REAL *) array, MAX_X + 1, MAX_Y + 1,
	      1, G_SIDE_NONE, 2, 1);
    g_sleep (3.0);
    g_cls ();

	a = (G_REAL **)malloc(sizeof(G_REAL *) * (M + 1));
	if (a == NULL) {
		fprintf(stderr, "error\n");
		exit(1);
	}
	for (i = 0; i <= M; i++) {
		a[i] = (G_REAL *)malloc(sizeof(G_REAL) * (N+1));
		if (a[i] == NULL) {
			fprintf(stderr, "error2\n");
			exit(1);
		}
	}
	for (i = 0; i <= M; i++)
		for (j = 0; j <= N; j++)
			a[i][j] =  sin((i-M/2) * dx) * sin((j-N/2) * dy);
    g_hidden2 (1.0, 1.0, 0.4, -1.0, 1.0, 5.0, 25.0, 20.0, 20.0, 20.0,
	      150.0, 100.0, (G_REAL **) a, M + 1, N + 1,
	      1, G_SIDE_NONE, 2, 1);
    g_sleep (3.0);

printf("g_fake_hidden()\n");
    g_cls ();
    g_fake_hidden (-1.0, 1.0, 0.8, 0.6, 20.0, 20.0, 150.0, 100.0,
		   (G_REAL *) array, MAX_X + 1, MAX_Y + 1,
		   1, G_SIDE_NONE, 2, 1);
    g_sleep (3.0);

    g_cls ();
    g_fake_hidden2 (-1.0, 1.0, 0.8, 0.6, 20.0, 20.0, 150.0, 100.0,
		   (G_REAL **) a, M + 1, N + 1,
		   1, G_SIDE_NONE, 2, 1);
    g_sleep (3.0);

printf("g_contln()\n");
    g_cls ();
    g_sel_scale (4);
    g_line_width (1);
    g_box (-1.0, 1.0, -1.0, 1.0, G_YES, G_NO);
    for (i = 1; i < 7; i ++)
    {
	g_line_color (i);
	g_contln (-1.0, 1.0, -1.0, 1.0, (G_REAL *) array,
		  MAX_X + 1, MAX_Y + 1, 0.32 * i - 1.12);
    }
    g_sleep (3.0);

    g_cls ();
    g_box (-1.0, 1.0, -1.0, 1.0, G_YES, G_NO);
    for (i = 1; i < 7; i ++)
    {
	g_line_color (i);
	g_contln2 (-1.0, 1.0, -1.0, 1.0, (G_REAL **) a,
		  M + 1, N + 1, 0.32 * i - 1.12);
    }
    g_sleep (-1.0);

    /* Termination */ 
    g_term ();
}
