/*
 * matrix.h
 */

#ifndef MATUTIL
#define MATUTIL

#include <stdio.h>
#include <stdlib.h>

#ifndef scalar
#define scalar double
#endif

typedef int    *ivector;
typedef float  *fvector;
typedef double *dvector;
typedef scalar *vector;

typedef ivector *imatrix;
typedef fvector *fmatrix;
typedef dvector *dmatrix;
typedef vector *matrix;

ivector new_ivector();
void free_ivector();

fvector new_fvector();
void free_fvector();

dvector new_dvector();
void free_dvector();

vector new_vector();
void free_vector();

imatrix new_imatrix();
void free_imatrix();

fmatrix new_fmatrix();
void free_fmatrix();

dmatrix new_dmatrix();
void free_dmatrix();

matrix new_matrix();
void free_matrix();

double dotprod();
#endif
